package com.nisum.ecomcustomer.config.mongodb;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.mongodb.config.AbstractMongoClientConfiguration;
import org.springframework.data.mongodb.config.EnableMongoAuditing;
import org.springframework.data.mongodb.repository.config.EnableMongoRepositories;

import static com.nisum.ecomcustomer.config.mongodb.CustomMongoConverters.*;
import static org.springframework.data.mongodb.core.convert.MongoCustomConversions.MongoConverterConfigurationAdapter;

@EnableMongoRepositories("com.nisum.ecomcustomer.repository")
@Configuration
@EnableMongoAuditing
public class MongoConfig extends AbstractMongoClientConfiguration {

    @Value("${spring.data.mongodb.database}")
    private String databaseName;

    @Override
    protected String getDatabaseName() {
        return databaseName;
    }

    @Override
    protected void configureConverters(MongoConverterConfigurationAdapter adapter) {
        adapter.registerConverter(new CustomerTypeToIntegerConverter());
        adapter.registerConverter(new IntegerToCustomerTypeConverter());
        adapter.registerConverter(new AddressTypeToStringConverter());
        adapter.registerConverter(new StringToAddressTypeConverter());
    }
}




