package com.nisum.ecomcustomer.config.mongodb.listeners;

import com.nisum.ecomcustomer.model.Customer;
import com.nisum.ecomcustomer.model.DbSequence;
import com.nisum.ecomcustomer.repository.DbSequenceRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.mapping.event.AbstractMongoEventListener;
import org.springframework.data.mongodb.core.mapping.event.BeforeConvertEvent;
import org.springframework.stereotype.Component;

import java.time.LocalDate;

@Component
public class CustomerDbOpsEventListener extends AbstractMongoEventListener<Customer> {

    @Autowired
    DbSequenceRepository dbSequenceRepository;

    @Override
    public void onBeforeConvert(BeforeConvertEvent<Customer> event) {
        super.onBeforeConvert(event);
        Customer source = event.getSource();
        if (source.getId() == null) {
            DbSequence dbSequence = dbSequenceRepository.findBySequenceName(Customer.SEQUENCE_NAME).orElse(new DbSequence(Customer.SEQUENCE_NAME));
            source.setId(dbSequence.incrementLastId());
            source.setEmail(source.getEmail().toLowerCase());
            source.setCreatedDate(LocalDate.now());
            dbSequenceRepository.save(dbSequence);
        }
    }

}
