package com.nisum.ecomcustomer.model;

import lombok.Data;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

@Data
@Document("database_sequences")
public class DbSequence {

    @Id
    private String id;

    @Field("seq_name")
    @Indexed
    private String sequenceName;

    private Long lastId;

    public DbSequence(String sequenceName) {
        this.sequenceName = sequenceName;
        this.lastId = 0L;
    }

    public Long incrementLastId() {
        return ++lastId;
    }

}
